
#include <stdlib.h>

#include "crc32.h"
#include "typesize.h"

static char tableavailable = 0;
static U32 *crc_table;

void gen_table(void)	/* build the crc table */
{
    U32 crc, poly;
    int	i, j;

    if (!tableavailable)
	crc_table = (U32*) malloc(256 * sizeof(crc_table[0]));

    poly = 0xEDB88320L;
    for (i = 0; i < 256; i++)
	{
	crc = i;
	for (j = 8; j > 0; j--)
	    {
	    if (crc & 1)
		crc = (crc >> 1) ^ poly;
	    else
		crc >>= 1;
	    }
	crc_table[i] = crc;
	}
    tableavailable = 1;
}


U32 crc32(unsigned char *buf, int len)	/* calculate the crc value */
{
    register U32 crc;

    if (!tableavailable)
	gen_table();

    crc = ~0L;
    while (len--)
	crc = (crc>>8) ^ crc_table[ ( ((unsigned char)(crc))^*buf++)  ];

    return ~crc;
}

